if(!dojo._hasResource["com.ibm.customize.ResultsList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.ResultsList"] = true;
// This controls the list of results in the customization shelf.  It handles searching datastores and paging.  It usually works with a com.ibm.customize.Container as its parent.

dojo.provide("com.ibm.customize.ResultsList");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

dojo.declare("com.ibm.customize.ResultsList",
	[dijit._Widget, dijit._Templated],
	{
		source: null,						// the source which is currently selected for searching
		parent: null, 						// the parent container for this widget
		searchTerms: [], 					// an array of search terms for fetch 
		currRequest: null,					// the current fetch request
		size: 9,							// the number of results displayed at once
		start: 0,							// the index of the first result displayed in the section
		totalItemCount: 0,					// the total number of items matched by the last search query
		draggable: false,					// true if items are draggable off the shelf
		dndType: "ibmPortalShelfItem",		// dnd type of items that are draggable
		cssClass: "",
		events: [],
		secondCssClass: "lotusPaletteWidgetContainer",
		listHtmlType: "div",
		templateString: '<div dojoAttachPoint="focusNode" class="${cssClass}">' +
							'<div class="${secondCssClass}">' +
								'<${listHtmlType} dojoAttachPoint="table"></${listHtmlType}>' +
							'</div>' +
							'<div class="lotusPaging">' +
								'<div class="lotusLeft" dojoAttachPoint="pagingStatus"></div>' +
								'<div dojoAttachPoint="jumpToLink" class="ibmJumpToLink"></div>' +
								'<ul class="lotusRight lotusInlinelist">' +
									'<li class="lotusFirst" dojoAttachPoint="prevLink"></li>' +
									'<li dojoAttachPoint="nextLink"></li>' +
								'</ul>' +
							'</div>' +
						'</div>',
		
		constructor: function() {
			this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.newCell = function(){};
		},
		
		postMixInProperties: function(){
			// summary: if this object was created without a parent, provide self with items usually provided by the parent object
			if(!this.parent){
				this.parent = {
					id:this.id,
					createLotusMsgNode: function(message,type){
						var err = dojo.create("div",{className:"lotusMessage lotus" + type, style:{ marginRight:"15px" }});
						var img = dojo.create("img",{src:this.imagePath + "/icon" + type + ".gif", alt:message});
						var msg = dojo.create("span",{innerHTML:message});
						err.appendChild(img);
						err.appendChild(msg);
						return err;
					},
					newCell: this.newCell
				}
			}
		},
		
		postCreate: function(){ 
			// summary: subscribes to events for when the search terms changes, the source changes, the user wants to add a saved search, or the size of the browser window adjusts
			this.events.push(dojo.subscribe("/epc/customize/search"+this.parent.id, this, this.changeSearchTerms));
			this.events.push(dojo.subscribe("/epc/customize/changeSource"+this.parent.id, this, this.changeSource));
			if(this.source) this.changeSource(this.source);
			if(this.draggable) this.setUpDndSource();
		},
		
		/**********************************/
		/*               DND              */
		/**********************************/
			
		setUpDndSource: function(){
			var cls = dojo.getObject(ibmPortalConfig.portletDndSource || "com.ibm.pb.dnd.layout.ShelfSource");
			if(!cls) return;
			this.dndSource = new cls(
				this.table,{
				creator: ibmPortalConfig.portletDndSource ? this.creator : cls.creator, 
				accept: [], 
				singular: true,
				skipForm: true,
				copyOnly: true,
				selfAccept: false,
				selfCopy: false,
				copyState: function(){	return true; }
			});
			this.events.push(dojo.subscribe("/dnd/drop", this, "onDrop"));
		},
		
		makeCellDraggable: function(cell){
			dojo.addClass(cell, "dojoDndItem dojoDndHandle");
			var control = dojo.query(".lotusInner", cell)[0];
			dojo.addClass(control,"ibmPortalControl");
			dojo.attr(cell, "dndType", this.dndType);
		},
		
		creator: function(item, hint){
			if(hint == "avatar"){
				var node = dojo.dnd.manager().nodes[0];
				var widget = dijit.byId(node.id);
				var title = (widget) ? widget.truncTitleText : "";
				var node = dojo.create("div",{className:"ibmPortalShelfAvatar",innerHTML:title});
				return {node: node, data: item, type: [this.dndType]};
			}
		},
		
		onDrop: function(source, nodes, copy){
			if(typeof com.ibm.portal.dnd != "undefined" && typeof com.ibm.portal.dnd.PORTLET_MEDIATOR != "undefined"){
				if(com.ibm.portal.dnd.PORTLET_MEDIATOR.currentType == this.dndType){
					com.ibm.portal.dnd.PORTLET_MEDIATOR.fromShelf = true;
					var widget = dijit.byId(nodes[0].id);
					widget.apply();
				}
			}
		},
		
		/**********************************/
		/*            SEARCH              */
		/**********************************/
		
		changeSearchTerms: function(/*String[]*/ searchTerms){
			// summary: does a new search when the filters change
			// searchTerms: an array of strings which are filters
			this.searchTerms = searchTerms;
			this.start = 0;
			this._search();
		},
		
		changeSource: function(/*Object*/ source){
			// summary: does a fresh search with no filters when the hub changes
			// source: the new source to search
			if(!source.hub.fetch) {
				this.clear();
				return;
			}
			if(this.currRequest) this.currRequest.abort();  // make sure any unfinished request is aborted
			this.source = source;
			this.searchTerms = [];
			this.start = 0;
			if(source.hub.noIcons) dojo.addClass(this.domNode.parentNode,"lotusPlain");
			else dojo.removeClass(this.domNode.parentNode,"lotusPlain");
			this._search();
		},
		
		_search: function(){
			// summary: does a fetch operation on the hub and fills the table with the results
			if(this.source.hub == null){
				// alert the user if the hub is null and clear out old info on the paging bar
				this.addMessage("Error",dojo.string.substitute(this.shelfBundle["shelf_badDatastoreError"], [this.source.label]));
				return;
			} else this.setLoading();
			
			// See dojo.data.api.Read.fetch()
			this.currRequest = this.source.hub.fetch({
				queryOptions: { ignoreCase: true },
				query: { keywords: this.searchTerms }, // query is the array of filters that the hub handles in its own way
				count: this.size,
				start: this.start,  
				
				onComplete: dojo.hitch(this, function(/*DatastoreItem[]*/items) {
					// summary: uses the items returned from the search to adjust what is displayed on the paging bars, and fill the table with results
					if(this.parent.filterAdd){
						// filter out any items that should not be displayed
						filterFcn = dojo.hitch(this,function(item){ return this.parent.filterAdd(this.source.hub.mapItem(item)); })
						items = dojo.filter(items,filterFcn);
					}
					if(items.length == 0) this.addMessage("Warning",this.shelfBundle["shelf_noResults"]);
					else this.fill(items);
				}),
				
				onError: dojo.hitch(this, function(/*String*/error, /*Object*/request) {
					console.error("error loading this category: " +error);
					// summary: displays an error message in the table and clears out old info on the paging bar
					if  (error.status == 401) {
						ibm.portal.debug.text( "Basic auth 401 found, trigger reload");
						var authObj = dojo.getObject("com.ibm.ajax.auth");
						if(authObj) com.ibm.ajax.auth.authenticationHandler();
						else window.location.reload();
						return;
					}
					this.clear();
					this.addMessage("Error", dojo.string.substitute(this.shelfBundle["shelf_feedError"], [this.source.label]));
				}),
				
				onBegin: dojo.hitch(this, function(totalNumber) {
					// summary: records the number of results returns in the current query
					this.totalItemCount = totalNumber;
				})
			});
		},
		
		/***********************************/
		/*              TABLE              */
		/***********************************/
		
		setLoading: function() {
			// summary: adds a loading indicator, for use before search results are appended
			this.clear();
			this.table.appendChild(document.createTextNode(this.shelfBundle["shelf_loading"]));
		},
		
		addMessage: function(/*String*/type,/*String*/msg){
			// summary: clears out the table and then builds it back up enough to enter a single message into the table
			// msg: the message to enter in the table
			this.clear();
			// create the cell
			var message = this.parent.createLotusMsgNode(msg,type);
			this.table.appendChild(message);
			// reset search numbers to 0 and adjust the info on the paging bar
			this.start = 0;
			this.totalItemCount = 0;
		},
		
		clear: function(){
			// summary: clears out the table
			var items = dojo.query(".lotusPaletteWidget",this.table);
			dojo.forEach(items, dojo.hitch(this, function(item){
				dijit.byId(item.id).destroy();
			}));
			this.table.innerHTML = "";
			this.pagingStatus.innerHTML = "";
			this.jumpToLink.innerHTML = "";
			this.prevLink.innerHTML = "";
			this.nextLink.innerHTML = "";
		},
		
		fill: function(/*DatastoreItem[]*/contents){
			// summary: fills the table with rows of catalog item results
			// contents: array holding DatastoreItems to be entered in the table
			this.clear();
			dojo.forEach(contents, dojo.hitch(this, function(item) {
				var newCell = this.parent.newCell(this.source,item);
				if(this.draggable) this.makeCellDraggable(newCell);
				this.table.appendChild(newCell);
			}));	
			this.adjustPagingBar();
			if(this.draggable && this.dndSource) this.dndSource.sync();
		},
		
		/************************************/
		/*              PAGING              */
		/************************************/
		
		prev: function(){
			// summary: triggers when the user clicks the Previous link,
			this.start = this.start - this.size;
			this._search();
		},
		
		next: function(){
			// summary: triggers when the user clicks the Next link
			this.start = this.start + this.size;
			this._search();
		},
		
		jumpTo: function(/*Event*/e){
			// summary: triggers when a user jumps to a new page
			// event: the onkeydown event
			e = dojo.fixEvent(e, e.target);
			var key = e.keyCode;
		
			if(key == dojo.keys.ENTER){
				var input = this.jumpToInput.value;
				// if number is not an integer, return
				if(input.toString().search(/^[0-9]+$/) != 0)  return;
				// if number is less than 1, set it to 1
				if(input < 1) input = 1;
				
				// calculate the new starting index for result items and make sure it's within range
				var userInputStart = (input - 1) * this.size;
				var maxStart = (Math.ceil(this.totalItemCount/this.size) - 1) * this.size;
				this.start = (userInputStart < maxStart)?userInputStart:maxStart;
				// search with the new starting index
				this._search();
			}
		},
		
		adjustPagingBar: function(){
			// summary: triggers when a search is performed to make sure the numbers and contents of the bar match up
			var firstItem = (this.totalItemCount == 0)?0:this.start + 1;
			var lastItem = this.start + this.size;
			lastItem = (this.totalItemCount > lastItem)?lastItem:this.totalItemCount;
			
			// displays "Page X of Y" in the paging bar
			var currentPage = Math.ceil(firstItem/this.size);
			var totalPageCount = Math.ceil(this.totalItemCount/this.size);
			this.pagingStatus.innerHTML = dojo.string.substitute(this.shelfBundle["shelf_page"], [currentPage, totalPageCount]);
			
			// create Previous and Next links , and Jump to page ___  if appropriate
			this.createPrevNode(firstItem);
			this.createNextNode(lastItem);
			if(this.totalItemCount > this.size) this.createJumpTo(firstItem);
		},
		
		createPrevNode: function(/*Int*/firstItem){
			// summary: determines if a Previous link should be rendered and creates it if appropriate
			if(firstItem > 1){  // create a link
				var prev = dojo.create("a", {href:"javascript:void(0)",innerHTML:this.shelfBundle["shelf_previous"]});
				prev.onclick = this._createPrevNodeEventHandlers().onclick;
				this.prevLink.appendChild(prev);
			}
			else  // create unclickable text
				this.prevLink.appendChild(document.createTextNode(this.shelfBundle["shelf_previous"]));
		},
		
		_createPrevNodeEventHandlers: function () {
			return {
				onclick: dojo.hitch(this, function(){ this.prev(); return false; /* to prevent onBeforeUnload event from triggering in IE */ })
			};
		},
		
		createNextNode: function(/*Int*/lastItem){
			// summary: determines if a Next link should be rendered and creates it if appropriate
			if(this.totalItemCount > lastItem){  // create a link
				var next = dojo.create("a", {href:"javascript:void(0)",innerHTML:this.shelfBundle["shelf_next"]});
				next.onclick = this._createNextNodeEventHandlers().onclick;
				this.nextLink.appendChild(next);
			}
			else // create unclickable text
				this.nextLink.appendChild(document.createTextNode(this.shelfBundle["shelf_next"]));
		},
		
		_createNextNodeEventHandlers: function () {
			return {
				onclick: dojo.hitch(this, function(){ this.next(); return false; /* to prevent onBeforeUnload event from triggering in IE */ })
			};
		},
		
		createJumpTo: function(firstItem){
			// summary: if there is  more than one page available, this creates a "Jump to page ___" input
			this.jumpToInput = dojo.create("input",{type:"text",value:Math.ceil(firstItem/this.size),className:"lotusText","id":this.parent.id+"_jumpTo", onfocus:"this.select()"});
			dojo.connect(this.jumpToInput, "onkeydown", this, this.jumpTo);
			this.jumpToLink.appendChild(dojo.create("label",{"innerHTML":this.shelfBundle["shelf_jumpTo"],"for":this.parent.id+"_jumpTo"}));
			this.jumpToLink.appendChild(this.jumpToInput);
		},
		
		destroy: function(){
			dojo.forEach(this.events, dojo.unsubscribe);
			this.events = null;
			this.clear();
			this.inherited(arguments);
		}
});

}
