if(!dojo._hasResource["com.ibm.customize.TabbedController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.TabbedController"] = true;
 // This is tabbed container with controller children
dojo.provide("com.ibm.customize.TabbedController");

dojo.require("com.ibm.UnloadGuard");
dojo.require("com.ibm.widgets.InlineShelf");
dojo.require("dojo.i18n");
dojo.require("dojo.DeferredList");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

dojo.declare("com.ibm.customize.TabbedController",
	[com.ibm.widgets.InlineShelf],
	{
		children: [],					// array of children to display in the tabs, each array item is an object {tabName:"",controller:object that implements the Customize Controller API}
		pendingChildren: 0,				// the number of children with pending changes used to determine whether or not the save link should be enabled
		imagePath: '.',					// path to the css images
		hiddenClass: "lotusHidden",		// the css class name to hide content panes
		selectedClass: "lotusSelected",	// the css class to select tabs
		transitions:true, 				// true if com.ibm.portal.fx.Transitions should be used when saving children
		templateString: '<div class="lotusui ibmPortalCustomizeShelf lotusPalette" style="display: none;">' +
							'<div class="lotusPaletteHeader">' +
								'<ul dojoAttachPoint="tabs" class="lotusTabs"></ul>' +
							'</div>' +
							'<div dojoAttachPoint="containerDivs"></div>' +
						'</div>',
		refreshRetryInterval: 300,		// if a refresh request is delayed because a save is pending, this is the amount of time to wait before retrying the refresh				
		
		constructor: function() {
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.okText = this.bundle.shelf_saveChanges;
			this.cancelText = this.bundle.add_content_cancel;
		},
		
		onFirstOpen: function(){
			this.fillTabs();
		},
		
		fillTabs: function(){
			// create the tabs and container divs for each child
			var clickFirstTab, first = true;
			dojo.forEach(
				this.children,
			    dojo.hitch(this, function(child){
					// create a node for the child to create its container
					var div = dojo.create("div",{className:this.hiddenClass});
					this.containerDivs.appendChild(div);
					div.appendChild(child.controller.domNode);
					child.containerDiv = div;
					// create a tab div to access the container
					var tab = dojo.create("li");
					var tabName = dojo.create("a",{innerHTML:child.controller.tabLabel,href:"javascript:void(0)"});
					tab.appendChild(tabName);
					this.tabs.appendChild(tab);
					child.tab = tab;
					// create an onclick handler for each tab that opens its container
					tabName.onclick = dojo.hitch(this,this.showTab,child);
					// connect to the child's dirty attribute
					this.connect(child.controller, "makeDirty", "modifyPending");
					// if it's the first child, select its tab
					if(first) {
						first = false;
						clickFirstTab = tabName.onclick;
					}
			}));
			clickFirstTab(); 
			this.onStartup();
		},
		
		undoChildren: function(){
			// summary: undoes all pending changes in the children
			dojo.forEach( this.children, dojo.hitch(this, function(child){ 
				child.controller.undo();	
			}));
		},
		
		saveChildren: function(){
			// summary: saves all pending changes in the children and refreshes the page if necessary
			// check if there are any changes in the controllers
			if (!this.pendingChildren) {
				return;
			}
			var closeOverlay = this.transitions ? this.children[0].controller.showWaitMsgInDialog(this.bundle.shelf_saving) : function(){};
			this.beforeSave().addCallback(dojo.hitch(this, "_proceedSave", closeOverlay));
		},
		
		_proceedSave: function(closeOverlay) {
			// count function keeps track of how many children are done submitting
			// when count is 0, all children have finished submitting
			var refresh = false;
			var count = this.children.length;
			var counter = dojo.hitch(this,function(){
				if(--count === 0) {
					if (this.transitions) {
						closeOverlay();
					}
					if (refresh) {
						this.refreshPage();
					}
				}
			});
			var handleError = dojo.hitch(this,function(errors){
				counter();
				var message = errors[0].message;
				var details = errors[0].responseText;
				if(message.match(/\D401/)){ // Portal session not authenticated
					details = message;
					message = this.bundle.shelf_session_timeout;
				}
				var statusMessage = new com.ibm.widgets.StatusMessage( "error", message, details );
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
			});
			// call beforeSubmit on each child
			var dfdl = new dojo.DeferredList(dojo.map( this.children, function(child){
				return child.controller.beforeSubmit();
			}, this));
			dfdl.addCallback(dojo.hitch(this, function(){
				// call submit on each child
				dojo.forEach( this.children, function(child){ 
					if (child.controller.refresh && child.controller.dirty) {
						refresh = true;
					} 
					child.controller.submit({onComplete:counter,onError:handleError});	
				}, this);
			}));
		},
		
		portalBeforeSave: function(callback){
			if(!this.pendingChildren) { 
				callback(); 
				return; 
			} 
			this.closeOverlay = this.transitions ? this.children[0].controller.showWaitMsgInDialog(this.bundle.shelf_saving) : function(){};
			var dfdl = new dojo.DeferredList(dojo.map( this.children, function(child){
				return child.controller.beforeSubmit();
			}, this));
			dfdl.addCallback(dojo.hitch(this, callback));
		},
		
		portalSave: function(callback){
			if (!this.pendingChildren) {
				return;
			}
			var refresh = false;
			var count = this.children.length;
			var counter = dojo.hitch(this,function(){
				if(--count === 0) {
					callback();
					if (this.transitions) {
						this.closeOverlay();
					}
					if (refresh) {
						this.refreshPage();
					}
				}
			});
			var handleError = dojo.hitch(this,function(errors){
				counter();
				var message = errors[0].message;
				var details = errors[0].responseText;
				if(message.match(/\D401/)){ // Portal session not authenticated
					details = message;
					message = this.bundle.shelf_session_timeout;
				}
				var statusMessage = new com.ibm.widgets.StatusMessage( "error", message, details );
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
			});
			dojo.forEach( this.children, function(child){ 
				if (child.controller.refresh && child.controller.dirty) {
					refresh = true;
				} 
				child.controller.submit({onComplete:counter,onError:handleError});	
			}, this);
		},
		
		refreshPage: function () {
			// summary: Reloads the page to show any changes that require the page to be completely reloaded to render. If a save is currently in progress,
			//		the reload request will be queued until the save operation completes. 
			if (ibmPortalConfig.savePageManager && !ibmPortalConfig.savePageManager.isDirty()) {
				com.ibm.utilities.refreshPage();
			} else {
				//A refresh has been requested, but we need to wait until the save is completed before honoring it.
				setTimeout( dojo.hitch( this, this.refreshPage ), this.refreshRetryInterval );
			}
		},
		
		modifyPending: function(/*bool*/change){
			// summary: changes the value of the pendingChildren variable
			if (change) {
				this.pendingChildren++;
			}
			else {
				this.pendingChildren--;
			}
			if (change) {
				this.makeDirty();
			}
		},
		
		makeDirty: function(){},  // used for Save Page Manager to connect to
		
		showTab: function(/*Object*/selectedChild){
			// summary: displays the content pane for the given controller
			// selectedChild: the child to show
			
			if(!selectedChild.controller.started){
				// if the child isn't started yet, start it up
				selectedChild.controller.startup(this);
			}
			// clear all the tabs and container divs
			dojo.forEach(
				this.children,
			    dojo.hitch(this, function(child){
					dojo.removeClass(child.tab,this.selectedClass);
					dojo.addClass(child.containerDiv,this.hiddenClass);
			}));
			// select and show the given child
			dojo.addClass(selectedChild.tab,this.selectedClass);
			dojo.removeClass(selectedChild.containerDiv,this.hiddenClass);
			this.onShowTab(selectedChild);
			return false; /* to prevent onBeforeUnload event from triggering in IE */
		},
		
		onStartup: function(){
			// summary: stub event to be called when the TabbedController is started up
		},
		
		onShowTab: function(/*Object*/selectedChild){
			// summary: stub event to be called whenever a tab is shown
		},
		
		beforeSave: function(){
			// summary: stub event to be called when saveChildren is called.  Returns a Deferred
			//		which is fired when save processing can be continued.
			var dfd = new dojo.Deferred();
			dfd.callback();
			return dfd;
		}
});

}
