if(!dojo._hasResource["com.ibm.mm.builder.widget.MumHeightResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumHeightResizer"] = true;
dojo.provide("com.ibm.mm.builder.widget.MumHeightResizer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.widget.MumHeightResizer", 
	[dijit._Widget, dijit._Templated],{
	
	templateString: 
		'<div dojoAttachEvent="onmousedown:_beginHeightSizing" class="mumHeightResizeHandler" style="display:none">'+
			'<img dojoAttachPoint="resizeHandlerImage" src="/mum/images/resize.png" alt="resize" title=""/>'+
		'</div>',
			
	minHeight:40,
	
	targetElmId:null,
	
	contentElmId:null,
	
	widgetBodyElmId:null,
	
	postCreate: function(){
		if(builderConfig.isBidi){
			this.resizeHandlerImage.src = "/mum/images/resize_rtl.png";
		}
		if (dojo.isIE == 6) {
			if (builderConfig.isBidi) {
				dojo.style(this.domNode, {
					left: "-8px",
					bottom: "-33px"
				});
			} else {
				dojo.style(this.domNode, {
					right: "-8px",
					bottom: "-33px"
				});
			}
		}
	},

	_beginHeightSizing: function(/*Event*/ e){
		if (this._isSizing){ return false; }
		if (!this.targetElmId){ return; }
		this._isSizing = true;
		if (dojo.isIE){
			this.startPointHeight  = event.clientY;
		}else{
			this.startPointHeight  =e.clientY;
		}
		var mb = dojo._getContentBox(dojo.byId(this.targetElmId));
		this.startHeight  = mb.h;

		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeHeightSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endHeightSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endHeightSizing")); 

		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_StartHeightSizing, [this.targetElmId]);
		e.preventDefault();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
	
	_changeHeightSizing: function(/*Event*/ e){
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){ return; }				
			}else{
				if(!e.clientX  || !e.clientY){ return; }				
			}
		}catch(ex){
			return;
		}

		var dy;
		if (dojo.isIE){
			dy = this.startPointHeight - event.clientY;
		}else{
			dy = this.startPointHeight - e.clientY;
		}
		
		var newH = this.startHeight - dy;
		// minimum height check
		if (this.minHeight) {
			var mb = dojo._getContentBox(dojo.byId(this.targetElmId));
			if (newH < this.minHeight) {
				newH = mb.h;
			}
		}
		dojo.style(dojo.byId(this.targetElmId),"height",newH+"px");
		
		if (this.contentElmId){
			var contentDiv = dojo.byId(this.contentElmId);			
			if (builderConfig.isBidi && 
				   com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustHeightResizer(contentDiv,newH)) {
			} else {								
				if(!this.widgetBodyPadTop){
					this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(this.widgetBodyElmId),"paddingTop");
					if (this.widgetBodyPadTop) {
						this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop,10);
					} else {
						this.widgetBodyPadTop = 0;
					}
				}
				var hei = newH - this.widgetBodyPadTop;				
				dojo._setMarginBox(contentDiv,0,0,-1,hei);
			}
		}
				
		// Publish to the change height sizing topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_ChangeHeightSizing, [dy]);
		e.preventDefault();
	},

	_endHeightSizing: function(/*Event*/ e){
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		} 

		// Publish to the end height sizing event topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_EndHeightSizing);
		var widgets = dojo.query(".iWidgetSkin[skin]", dojo.byId(this.targetElmId));
		if (widgets.length == 1) {
			// old topic
			dojo.publish(widgets[0].id + com.ibm.mm.builder.eventTopics.Resize_EndHeightSizing, [e]);
			
			// new enabler public ievent
			var widgetBox = dojo.contentBox(widgets[0].id + "_content");
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
			eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgets[0].id,payload);
			
			// to fix the inconsistent widget size between nav state and backend
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgets[0].id, "normal");
			payload = {
				widgetId: widgets[0].id,
				height: parseInt(dojo.byId(this.targetElmId).style.height,10)
			};
			eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);		
		}
		dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, []);
	},
	
	destroy : function(){
		this.targetElmId = null;
		this.targetDomNode = null;
		this.inherited(arguments);
	},
	
	show: function(){
		if (com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit") {
			return;
		}
		
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "";
			}
		}), 100);
	},
	
	hide: function(){
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow) {
			return;
		}
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "none";
			}
		}), 100);
	}
});

}
