dojo.provide("com.ibm.pb.dijit.WidgetResizer");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");

dojo.declare("com.ibm.pb.dijit.WidgetResizer", [dijit._Widget, dijit._Templated],{
	templateString: 
		'<div dojoAttachEvent="onmousedown: _beginSizing" class="lotusWidgetResizer">'+
			'<div></div>'+
		'</div>',
		
	widgetId: null,
	//component-control node of the widget
	control: null,
	// contentElm: widget content dom node id
	contentElm: "",	

	widgetBodyElmId: "",
	
	minWidth:20,
	
	minHeight:20,
	
	oldHeight:0,
	
	// layout-container
	parentNode:null,
	
	intLeftRTLOrig:0,
	
	intOriginalWidth:0,
	
	isRtl: builderConfig.isBidi,
	
	postCreate: function(){
		if(this.isRtl){
			dojo.addClass(this.domNode, "rtl");
			// #16766 we shall set the left/right inline instead of using css class
			// because in rtl, the right=0 will also take effect
			dojo.style(this.domNode, "left", 0);
		} else {
			dojo.style(this.domNode, "right", 0);
		}
		this.runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.bEvents = com.ibm.mm.builder.eventTopics;
		//com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.changePageModeEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, "_onPageModeChanged");
		this.leaveFreeformEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.leaveFreeformContainer"+"."+this.widgetId, this, "_onleaveFreeform");
		this.enterFreeformEvt = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.enterFreeformContainer"+"."+this.widgetId, this, "_onenterFreeform");
		this._checkMode();
	},
	_checkMode: function(){
		if (this.runtimeModel.getCurrentPage().getPageMode() == "edit" && dojo.hasClass(this.parentNode,"ibmFreeform")){
			this.domNode.style.display="block";
		}else{
			this.domNode.style.display="none";
		}
	},
	_onPageModeChanged: function(iEvent){
		if(iEvent == "edit" && dojo.hasClass(this.parentNode,"ibmFreeform")){
			this.domNode.style.display="block";
		}else{
			this.domNode.style.display="none";
		}
	},
	_onleaveFreeform: function(iEvent){
		this.domNode.style.display="none";
	},
	_onenterFreeform: function(iEvent){
		this.domNode.style.display="block";		
	},
	_beginSizing: function(/*Event*/ e){
		this.maxSize = this.createMaxSize();
		if (this._isSizing){ 
			return false; 
		}
		
		this.targetDomNode = this.control;
		this.intLeftRTLOrig = parseInt(this.targetDomNode.style.left,10);
		this.intOriginalWidth = parseInt(this.targetDomNode.style.width,10);
		
		if (!this.targetDomNode) {
			return;
		}
		this._isSizing = true;
		
		if (dojo.isIE){
			this.startPoint  = {'x':event.clientX, 'y':event.clientY};
		}else{
			this.startPoint  = {'x':e.clientX, 'y':e.clientY};
		}

		var mb = dojo._getContentBox(this.targetDomNode);
		var widgetbody = dojo.byId(this.widgetId).parentNode;
		var wb = dojo._getContentBox(widgetbody);
		this.startSize  = {'w':mb.w, 'h':mb.h};
		this.startWidgetSize = {'w':wb.w, 'h':wb.h};
		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 

		// Publish to the start sizing topic
		dojo.publish(this.bEvents.Resize_StartSizing, [this.widgetId]);
		e.preventDefault();	
	},

	_changeSizing: function(/*Event*/ e){
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){
					return; 
				}				
			}else{
				if(!e.clientX  || !e.clientY){
					return; 
				}				
			}
		} catch (ex){
			// sometimes you get an exception accessing above fields...
			return;
		}

		var dx,dy;
		if (dojo.isIE){
			dx = this.startPoint.x - event.clientX;
			dy = this.startPoint.y - event.clientY;
		}else{
			dx = this.startPoint.x - e.clientX;
			dy = this.startPoint.y - e.clientY;
		}
		var newW;
		if(!this.isRtl){
			newW = this.startSize.w - dx;
		}else{
			newW = this.startSize.w + dx;	//for rtl
		}
		
		var newH = this.startSize.h - dy;
		var newWidgetH = this.startWidgetSize.h - dy;
		
		com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(this.control.id, newW, dx);
		// minimum size check
		var minWidthExceeded = newW < this.minWidth;
		if (minWidthExceeded) {
			newW = this.minWidth;
		}
		if (newH < this.minHeight) {
			newH = this.minHeight;
		}
		// maximum size check
		var maxWidthExceeded = newW > this.maxSize.w;
		if (maxWidthExceeded) {
			newW =this.maxSize.w;
		}
		if (newH > this.maxSize.h) {
			var _delta = this.startSize.h - this.startWidgetSize.h;
			newH = this.maxSize.h;
			newWidgetH = this.maxSize.h - _delta;
		}

		//In Right to Left, move the widget to the left by the same amount that the width is increased.
		var intLeft;
		if (this.isRtl) {
			if(minWidthExceeded){				
				intLeft = this.intLeftRTLOrig + (this.intOriginalWidth - this.minWidth);
			}else{				
				intLeft = maxWidthExceeded ? 0 : this.intLeftRTLOrig - dx;
			}
		}else{			
			intLeft = parseInt(this.targetDomNode.style.left,10);
		}
		
		var intTop = parseInt(this.targetDomNode.style.top,10);
		
		dojo._setBox(this.targetDomNode,intLeft,intTop,newW,newH);
		
		tempWidgetBody = dojo.byId(this.widgetId);
		if(!this.widgetBodyPadTop && tempWidgetBody){
			
			this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(tempWidgetBody ,"paddingTop");
			
			if (this.widgetBodyPadTop) {
				this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop,10);
			} else {
				this.widgetBodyPadTop = 0;
			}
		}

		var contentDiv = tempWidgetBody.parentNode;
		
		var hei = newWidgetH - this.widgetBodyPadTop;
		//hei + 10 for temp solve
		dojo._setMarginBox(contentDiv,0,0,newW,hei+10);
		
		if(this.skin){
			if(this.skin == "Thin"){
				var nht = hei - 20 ;
				tempWidgetBody.style.height = nht + "px";
			}else if(this.skin == "Standard"){
				var nhs = hei - 10;
				tempWidgetBody.style.height = nhs + "px";
			}
		}
		if (dojo.isSafari && builderConfig.isBidi) {
			contentDiv.style.width = (parseInt(this.targetDomNode.style.width,10) - 51) + "px";
		}
		this._updateContainer();
		// Publish to the change sizing topic
		var sizeDelta = {x: dx, y: dy};
		dojo.publish(this.bEvents.Resize_ChangeSizing, [sizeDelta]);
		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e){
		this.runtimeModel.getCurrentPage().setDirty(true);
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}
		dojo.publish(this.widgetId + this.bEvents.Resize_EndSizing, [e]);
		
		payload = {
			widgetId: this.widgetId,
			layoutControlId: this.layoutControlId,
			width: parseInt(this.targetDomNode.style.width,10),
			height: parseInt(this.targetDomNode.style.height,10),
			action: "only_save"
		}
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		dojo.style(dojo.body(),{cursor:"default"});
	},
	
	_updateContainer: function(){
		if(this.parentNode){
			var lcoords = dojo.coords(this.parentNode);
			var widgetBox = dojo.coords(this.control.id);
			if(widgetBox.t + widgetBox.h > lcoords.h){
				this.parentNode.style.height = (widgetBox.t + widgetBox.h) + "px";
			}
		}
	},
	
	createMaxSize:function(){
		var curWidget = this.control;
		if(curWidget && curWidget.parentNode){
			var curLeft = parseInt(curWidget.style.left,10);
			var curWidth = parseInt(curWidget.style.width,10);
			var curTop = parseInt(curWidget.style.top,10);	
			var wholeWidth = dojo._getContentBox(curWidget.parentNode).w;
			var wholeHeight = dojo._getContentBox(curWidget.parentNode).h;
			
			var maxWidth = this.isRtl ? curLeft + curWidth : wholeWidth - curLeft;
			return {
				w: maxWidth,
				h: wholeHeight - curTop
			};
		}
		return null;
	},
	

	destroy : function(){
		this.widgetId = null;
		this.targetDomNode = null;
		this.evtSvc.unsubscribeEvent(this.changePageModeEvt);
		this.evtSvc.unsubscribeEvent(this.leaveFreeformEvt);
		this.evtSvc.unsubscribeEvent(this.enterFreeformEvt);
		this.inherited(arguments);
	},
	
	onKeyPress: function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			this.show();
		}
	},
	
	show: function(){
		if (com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit") {
			return;
		}
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "";
			}
		}), 100);
	},
	
	hide: function(){
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow) {
			return;
		}
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "none";
			}
		}), 100);
	}
});
